/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To Rotate and Zoom an image file

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <math.h>
#include <wiiuse/wpad.h>

#include "gfx/pirate.h"


Mtx GXmodelView2D;


int main() {
    u32 wpaddown,wpadheld;
    float myzoom=0;
    float myrot=0;

    // Load the image file to a texture structure
    GRRLIB_texImg tex_pirate = GRRLIB_LoadTexture(pirate);


    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);
        wpadheld = WPAD_ButtonsHeld(0);

        //We fill the screen in white(RGBA format)
        GRRLIB_FillScreen(0xFFFFFFFF);

        //Display the image
        GRRLIB_DrawImg((640-tex_pirate.w)/2, (480-tex_pirate.h)/2, tex_pirate, myrot, sin(myzoom)+2, sin(myzoom)+2, 0xFFFFFFFF);

        GRRLIB_Render();

        myzoom+=0.02;

        if(wpadheld & WPAD_BUTTON_RIGHT) {
            myrot+=1;
        }

        if(wpadheld & WPAD_BUTTON_LEFT) {
            myrot-=1;
        }

        if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_pirate.data);
    return 0;
}
