/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To use Tile (part 1)

with GRRLIB_InitTileSet you can slice an image
in several part. In this example i will slice
my pirate image by lines, saying i want slice
of image width and 1 pixel hight.

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <math.h>
#include <wiiuse/wpad.h>

#include "gfx/pirate.h"

Mtx GXmodelView2D;


int main() {
    u32 wpaddown;
    float mysin1=0;
    float mysin1old=0;
    float mysin2=0;
    float mysin2old=0;
    int i;


    // Load the image file to a texture structure
    GRRLIB_texImg tex_pirate = GRRLIB_LoadTexture(pirate);
    // slice it
    GRRLIB_InitTileSet(&tex_pirate, tex_pirate.w, 1, 0);

    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);

        //We fill the screen in white(RGBA format)
        GRRLIB_FillScreen(0xFFFFFFFF);

        
        mysin1=mysin1old;
        mysin2=mysin2old;

        //Display the different slices
        for(i=0;i<tex_pirate.h;i++){
            GRRLIB_DrawTile(((640-tex_pirate.w)/2)+sin(mysin1)*50+sin(mysin2)*20, ((480-tex_pirate.h)/2)+i, tex_pirate, 0, 1, 1, 0xFFFFFFFF,i);
            mysin1+=0.02;
            mysin2+=0.05;
        }

        GRRLIB_Render();
        mysin1old+=0.02;
        mysin2old+=0.05;
        if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_pirate.data);
    return 0;
}
