/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To use Tile (part 2)

with GRRLIB_InitTileSet you can slice an image
in several part. I will use perso.png that is
an image where there is all the animation
sprite of a walking character. i will slice
this image for each movement of the animation.
each sprites are 32x32 pixel.

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <wiiuse/wpad.h>

#include "gfx/perso.h"

Mtx GXmodelView2D;


int main() {
    u32 wpaddown,wpadheld;
    float posx=0;
    float persotile=0;


    // Load the image file to a texture structure
    GRRLIB_texImg tex_perso = GRRLIB_LoadTexture(perso);
    // slice it
    GRRLIB_InitTileSet(&tex_perso, 32, 32, 0);

    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);
        wpadheld = WPAD_ButtonsHeld(0);

        //We fill the screen in black(RGBA format)
        GRRLIB_FillScreen(0x000000FF);

        GRRLIB_DrawTile(((640-tex_perso.tilew)/2)+posx, ((480-tex_perso.tileh)/2), tex_perso, 0, 2, 2, 0xFFFFFFFF,persotile);

        GRRLIB_Render();
        if(wpaddown & WPAD_BUTTON_LEFT){
            persotile=8;
        }
        if(wpaddown & WPAD_BUTTON_RIGHT){
            persotile=1;
        }

        if(wpadheld & WPAD_BUTTON_LEFT){
            posx--;
            persotile+=0.2;
            if(persotile>15) persotile=8;
        }
        else if(wpadheld & WPAD_BUTTON_RIGHT){
            posx++;
            persotile+=0.2;
            if(persotile>8) persotile=1;
        }
        else{
            persotile=0;
        }

       if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_perso.data);
    return 0;
}
