/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To GRRLIB_Printf

In fact GRRLIB_Printf use a bitmap font that is
stored in a png/jpg and is initialised like a 
normal tileset (each char is a tile)

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <wiiuse/wpad.h>

#include "gfx/console.h"
#include "gfx/font1.h"
#include "gfx/font2.h"
#include "gfx/font3.h"
#include "gfx/font4.h"

Mtx GXmodelView2D;


int main() {
    u32 wpaddown;

    // Load the image file and initilise the tiles
    GRRLIB_texImg tex_console = GRRLIB_LoadTexture(console);
    GRRLIB_InitTileSet(&tex_console, 8, 8, 0);

    // Load the image file and initilise the tiles
    GRRLIB_texImg tex_font1 = GRRLIB_LoadTexture(font1);
    GRRLIB_InitTileSet(&tex_font1, 32, 32, 32);

    // Load the image file and initilise the tiles
    GRRLIB_texImg tex_font2 = GRRLIB_LoadTexture(font2);
    GRRLIB_InitTileSet(&tex_font2, 16, 16, 32);

    // Load the image file and initilise the tiles
    GRRLIB_texImg tex_font3 = GRRLIB_LoadTexture(font3);
    GRRLIB_InitTileSet(&tex_font3, 32, 32, 32);

    // Load the image file and initilise the tiles
    GRRLIB_texImg tex_font4 = GRRLIB_LoadTexture(font4);
    GRRLIB_InitTileSet(&tex_font4, 32, 33, 32);


    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);

        GRRLIB_FillScreen(0x000000FF);
        GRRLIB_Printf(20, 32, tex_console, 0xFFFFFFFF, 1, "Here is an example with a 8x8 font");
        GRRLIB_Printf(20, 70, tex_font1, 0xFFFFFFFF, 1, "HERE IS ANOTHER");
        GRRLIB_Printf(20, 110, tex_font2, 0xFFFFFFFF, 1, "AND ONE NEW");
        GRRLIB_Printf(20, 150, tex_font3, 0xFFFFFFFF, 1, "HEHEH AND THIS ONE");

        GRRLIB_Printf(20, 200, tex_font4, 0xFFFFFFFF, 1, "THIS ONE IS COOL");
        GRRLIB_Printf(20, 240, tex_font4, 0xFF00FFFF, 1, "PLAYING WITH COLOR");
        GRRLIB_Printf(20, 280, tex_font4, 0xDDDDFFAA, 1, "AND WITH ALPHA");
        GRRLIB_Printf(20+10, 280+10, tex_font4, 0xFFFFFFAA, 1, "AND WITH ALPHA");

        GRRLIB_Render();

       if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_console.data);
    free(tex_font1.data);
    free(tex_font2.data);
    free(tex_font3.data);
    free(tex_font4.data);
    return 0;
}
