/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To use GRRLIB Bitmap effects

Keep in mind that some effects are a bit too
CPU eater to be used in realtime, so try as
possible to precalculate you new texture at
your program initialisation like this example.

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <wiiuse/wpad.h>

#include "gfx/png.h"

Mtx GXmodelView2D;


int main() {
    u32 wpaddown;

    // Load the image file
    GRRLIB_texImg tex_png = GRRLIB_LoadTexture(png);

    // We create an empty texture as the same size as our image
    GRRLIB_texImg tex_new = GRRLIB_CreateEmptyTexture(tex_png.w, tex_png.h);

    // We call the Bitmap effect blur with the effect factor value to 6
    GRRLIB_BMFX_Blur(tex_png, tex_new, 6);
    // And we ask GX to update the cache
    GRRLIB_FlushTex(tex_new);

    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);

        GRRLIB_FillScreen(0x000000FF);
        GRRLIB_DrawImg(30, 60, tex_png, 0, 1, 1, 0xFFFFFFFF);
        GRRLIB_DrawImg(230, 60, tex_new, 0, 1, 1, 0xFFFFFFFF);
        GRRLIB_Render();

       if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_png.data);
    free(tex_new.data);
    return 0;
}
