/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To use GRRLib Hot Zone Detection

A very easy implementation of GRRLIB_PtInRect
(point in a rectangle)

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <wiiuse/wpad.h>

#include "gfx/png.h"
#include "gfx/pointer.h"

Mtx GXmodelView2D;


int main() {
    ir_t ir1;
    u32 wpaddown;

    GRRLIB_texImg tex_pointer = GRRLIB_LoadTexture(pointer);
    GRRLIB_texImg tex_png = GRRLIB_LoadTexture(png);
    GRRLIB_texImg tex_new = GRRLIB_CreateEmptyTexture(tex_png.w, tex_png.h);
    GRRLIB_BMFX_Blur(tex_png, tex_new, 6);
    GRRLIB_FlushTex(tex_new);

    GRRLIB_Init();
    WPAD_Init();
    WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC_IR);

    while(1) {
        WPAD_SetVRes(0, 640, 480);
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);
        WPAD_IR(WPAD_CHAN_0, &ir1);

        GRRLIB_FillScreen(0x000000FF);
        if(GRRLIB_PtInRect(230+20, 60+20, tex_png.w-40, tex_png.h-40, ir1.sx+48, ir1.sy+48)){
            GRRLIB_DrawImg(230, 60, tex_png, 0, 1, 1, 0xFFFFFFFF);
        }
        else{
            GRRLIB_DrawImg(230, 60, tex_new, 0, 1, 1, 0xFFFFFFFF);
        }

        GRRLIB_DrawImg(ir1.sx, ir1.sy, tex_pointer, 0, 1, 1, 0xFFFFFFFF);
        GRRLIB_Render();

       if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_png.data);
    free(tex_new.data);
    free(tex_pointer.data);
    return 0;
}
