/*===========================================
        GRRLIB 4.0.0
        Code     : NoNameNo
        Additional Code : Crayon
        GX hints : RedShade

        How To Interact with texture

Here is how get and set pixel in texture
In this exemple it copy a 50x50 piece of the original
image to the new empty one.

============================================
Download and Help Forum : http://grrlib.santo.fr
============================================*/
#include "../../../GRRLIB/GRRLIB/GRRLIB.h"

#include <stdlib.h>
#include <wiiuse/wpad.h>

#include "gfx/png.h"

Mtx GXmodelView2D;


int main() {
    int x,y;
    u32 color;
    u32 wpaddown;

    GRRLIB_texImg tex_png = GRRLIB_LoadTexture(png);
    GRRLIB_texImg tex_new = GRRLIB_CreateEmptyTexture(48, 48);

    for(y=0;y<48;y++){
        for(x=0;x<48;x++){
            // it read the color of the pixel of the original image
            color = GRRLIB_GetPixelFromtexImg(x+128, y+100, tex_png);
            // and set it to our new empty texure
            GRRLIB_SetPixelTotexImg(x, y, tex_new, color);
        }
    }
    // Refresh the texture for the GX cache
    GRRLIB_FlushTex(tex_new);

    GRRLIB_Init();
    WPAD_Init();

    while(1) {
        WPAD_ScanPads();
        wpaddown = WPAD_ButtonsDown(0);

        GRRLIB_FillScreen(0x000000FF);
        GRRLIB_DrawImg(30, 60, tex_png, 0, 1, 1, 0xFFFFFFFF);
        GRRLIB_DrawImg(250, 60, tex_new, 0, 1, 1, 0xFFFFFFFF);
        GRRLIB_Render();

       if(wpaddown & WPAD_BUTTON_HOME) {
            exit(0);
        }
    }

    // Be a good boy, clear the memory allocated by GRRLIB
    GRRLIB_Exit(); 
    free(tex_png.data);
    free(tex_new.data);
    return 0;
}
